import os

def mostrar_tablero(tablero):
	s = ""
	for i in range(len(tablero)):
		s += tablero[i] + " "
		if(i%3 == 2):
			s += '\n'
	print(s)

def hay_ganador(tablero):
	for i in range(3):
		# horizontales
		if(tablero[3*i] == tablero[3*i+1] == tablero[3*i+2]):
			return True
		# verticales
		if(tablero[i] == tablero[3+i] == tablero[6+i]):
			return True
	# diagonales
	if(tablero[0]==tablero[4]==tablero[8] or tablero[2]==tablero[4]==tablero[6]):
		return True
	# si llego aquí, es porque aún no hay ganador
	return False

def es_empate(tablero):
	for i in range(len(tablero)):
		if(tablero[i] == str(i+1)):
			return False
	return True

def cargar(path, x, o):
	# Creo tablero nuevo
	turno = x
	tablero = []
	for i in range(1,10):
		tablero.append(str(i))
	# si hay tablero guardado lo cargo
	if(os.path.exists(path)):
		# sino, creo un nuevo tablero
		f = open(path)
		datos = f.readline().strip().split(';')
		f.close()
		turno,tablero = datos[0], datos[1:]
	return turno,tablero

def guardar(path, tablero,turno):
	f = open(path,'w')
	f.write(turno + ";" + ";".join(tablero))
	f.close()

# ruta al archivo donde guardo último juego
backup = './juego.txt'

# Para dar color al tablero
gris = '\033[90m'; rojo = '\033[91m'
azul = '\033[94m'; fin_color = '\033[0m'

# Defino variables del tablero
x = azul + "x" + fin_color; 
o =  rojo + "o" + fin_color; 

turno, tablero = cargar(backup, x, o)
while(True):
	# Muestro el tablero
	mostrar_tablero(tablero)

	# pido jugada 
	print("Turno",turno)
	pos = int(input("Ingrese movida:"))
	
	# Reacciono ante la movida, 
	# chequeo que casilla no esté ocupada
	# y le asigno el valor del turno (x/o)
	if(tablero[pos-1] == str(pos)):
		tablero[pos-1] = turno

	# Veo si se acabó el juego
	if(hay_ganador(tablero)):
		print("Gato! ganó", turno)
		break
	
	# Si no quedan casillas disponibles es un empate!
	if(es_empate(tablero)):
		print("Empate!")
		break

	# Cambio de turno
	if(turno == x): turno = o 
	else: turno = x

	# Guardo tablero actual
	guardar(backup, tablero, turno)


# Muestro tablero al final
mostrar_tablero(tablero)

# borro tablero por fin del juego
os.remove(backup)
